//your script here
var DEFAULT_URL; //Get Default from html file in setup().
var clock_url = "";
//  Dashboard Code (from apple)
function setup() {
	createGenericButton(document.getElementById('done'), 'done', hidePrefs);
	// get preferences
	DEFAULT_URL = document.getElementById("url").value;
	if(window.widget){
		var pref_url = widget.preferenceForKey("clock_url");
		if(pref_url && pref_url.length > 0){
			clock_url = pref_url;
		}else{
			alert("No Settings. Use Default.");
			clock_url = DEFAULT_URL;
		}
	} else { clock_url = DEFAULT_URL; }
	document.getElementById("url").value = clock_url;
	//
	createClock(clock_url);
	
	//to sleep in background
	if(window.widget){
		widget.onshow = onshow;
		widget.onhide = onhide;
	}
}

function onshow(){
	document.getElementById("clock").style.display="block";
}
function onhide(){
	document.getElementById("clock").style.display="none";
}

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");
       
	front.style.display="none";
	back.style.display="block";
	exitflip(event);

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	//Save Settings if changed
	var tfvalue = document.getElementById("url").value
	if(tfvalue != clock_url && tfvalue != ""){
		clock_url = tfvalue;
		if (window.widget){
			alert("clock_url changed.");
			widget.setPreferenceForKey(clock_url, "clock_url");
		}
		createClock(clock_url);
	}
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
      
	back.style.display="none";
	front.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

// Codes for NHK Clock
function createClock(url){
	var obj = document.createElement("object");
	obj.setAttribute("classid", "clsid:D27CDB6E-AE6D-11cf-96B8-444553540000");
	obj.setAttribute("codebase", "http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,29,0");
	obj.setAttribute("width", "200");
	obj.setAttribute("height", "160");
	//function to create param
	obj.innerHTML =
		'<param name="movie" value="'+url+'">'
		+'<param name="quality" value="high">'
		+'<param name="play" value="true">'
		+'<embed src="'+url+'" quality="high" pluginspage="http://www.macromedia.com/go/getflashplayer" type="application/x-shockwave-flash" width="200" height="160" play="ture"></embed>';
	
	document.getElementById("clock").innerHTML = obj.outerHTML;
}